using System;
using System.Collections.Generic;
using System.Text;
using System.Drawing.Design;
using System.Windows.Forms.Design;
using System.Windows.Forms;
using Components.Agenda.Frame;
using Components.Agenda.Management;
using Components.Agenda.Management.StructsEnums;
using Components.Calendar.MonthCal.Class;
using Utils.Misc;
using System.ComponentModel;
using Components.Calendar.MonthCal.GUI;
using System.Globalization;

namespace Components.TypeEditors
{
    /// <summary>
    /// Type editor for the selection of an hour
    /// </summary>
    public class UICalendarEditor : UITypeEditor
    {
        #region Variables
        /// <summary>
        /// LAnguage of the calendar
        /// </summary>
        private CalendarLanguage vCalendarLanguage;
        #endregion

        #region Mthodes
        /// <summary>
        /// Cf Doc
        /// </summary>
        /// <param name="context"></param>
        /// <returns></returns>
        public override UITypeEditorEditStyle GetEditStyle(System.ComponentModel.ITypeDescriptorContext context)
        {
            //return UITypeEditorEditStyle.DropDown;
            return UITypeEditorEditStyle.Modal;
        }

        /// <summary>
        /// Cf Doc
        /// </summary>
        /// <param name="context"></param>
        /// <returns></returns>
        public override bool GetPaintValueSupported(System.ComponentModel.ITypeDescriptorContext context)
        {
            return false;
        }

        /// <summary>
        /// Cf Doc
        /// </summary>
        /// <param name="context"></param>
        /// <param name="provider"></param>
        /// <param name="value"></param>
        /// <returns></returns>
        public override object EditValue(System.ComponentModel.ITypeDescriptorContext context,
            IServiceProvider provider, object value)
        {
            if (provider != null)
            {
                IWindowsFormsEditorService editor =
                    (IWindowsFormsEditorService)provider.GetService(typeof(IWindowsFormsEditorService));

                if (editor != null && value != null)
                {
                    #region Affichage du menu de choix
                    //TODO: mettre un menu de selection
                    this.vCalendarLanguage = (CalendarLanguage)value;

                    IWindowsFormsEditorService wfes = (IWindowsFormsEditorService)provider.GetService(typeof(IWindowsFormsEditorService));
                    System.Windows.Forms.ComboBox cb = new System.Windows.Forms.ComboBox();
                    //System.Windows.Forms.ListBox cb = new System.Windows.Forms.ListBox();

                    cb.AutoCompleteMode = System.Windows.Forms.AutoCompleteMode.Suggest;
                    cb.AutoCompleteSource = System.Windows.Forms.AutoCompleteSource.ListItems;

                    foreach (string l in vCalendarLanguage.Languages)
                        cb.Items.Add(TextManager.FirstUpper(l));

                    wfes.DropDownControl(cb);
                    if (cb.SelectedIndex > 0)
                        this.vCalendarLanguage.SelectLanguage(cb.SelectedIndex);
                    #endregion
                }
            }
            return this.vCalendarLanguage;
        }
        #endregion
    }
    /// <summary>
    /// Provides a type converter to convert string objects to and from other representations.
    /// </summary>
    public class CalendarLanguageConverter : StringConverter
    {
        /// <summary>
        /// Returns whether this object supports a standard set of values that can be
        /// picked from a list, using the specified context.
        /// </summary>
        /// <param name="context">An System.ComponentModel.ITypeDescriptorContext that provides a format context.</param>
        /// <returns>true if System.ComponentModel.TypeConverter.GetStandardValues() should be
        /// called to find a common set of values the object supports; otherwise, false.</returns>
        public override bool GetStandardValuesSupported(ITypeDescriptorContext context)
        {
            //true means show a combobox
            return true;
        }
        /// <summary>
        /// Returns whether the collection of standard values returned from System.ComponentModel.TypeConverter.GetStandardValues()
        /// is an exclusive list of possible values, using the specified context.
        /// </summary>
        /// <param name="context">An System.ComponentModel.ITypeDescriptorContext that provides a format context.</param>
        /// <returns>true if the System.ComponentModel.TypeConverter.StandardValuesCollection
        /// returned from System.ComponentModel.TypeConverter.GetStandardValues() is
        /// an exhaustive list of possible values; false if other values are possible.</returns>
        public override bool GetStandardValuesExclusive(ITypeDescriptorContext context)
        {
            //true will limit to list. false will show the list, but allow free-form entry
            return true;
        }
        /// <summary>
        /// Returns whether the collection of standard values returned from System.ComponentModel.TypeConverter.GetStandardValues()
        /// is an exclusive list of possible values, using the specified context.
        /// </summary>
        /// <param name="context">An System.ComponentModel.ITypeDescriptorContext that provides a format context.</param>
        /// <returns>true if the System.ComponentModel.TypeConverter.StandardValuesCollection
        /// returned from System.ComponentModel.TypeConverter.GetStandardValues() is
        /// an exhaustive list of possible values; false if other values are possible.</returns>
        public override StandardValuesCollection GetStandardValues(ITypeDescriptorContext context)
        {
            CalendarLanguage value = new CalendarLanguage(((MonthCal)context.Instance).LanguageFile);
            StandardValuesCollection ret = new StandardValuesCollection(value.Languages);
            return ret;
            //return new StandardValuesCollection(value.Languages);
        }
        /// <summary>
        /// Converts the given object to the type of this converter, using the specified
        /// context and culture information.
        /// </summary>
        /// <param name="context">An System.ComponentModel.ITypeDescriptorContext that provides a format context.</param>
        /// <param name="culture">The System.Globalization.CultureInfo to use as the current culture.</param>
        /// <param name="value">The System.Object to convert.</param>
        /// <returns>An System.Object that represents the converted value.</returns>
        public override object ConvertFrom(ITypeDescriptorContext context, CultureInfo culture, object value)
        {
            //return base.ConvertFrom(context, culture, value);
            CalendarLanguage cl = new CalendarLanguage(((MonthCal)context.Instance).LanguageFile);
            cl.SelectLanguage((string)value);
            return cl.SelectedLanguage;
        }
    }
}
