using System;
using System.Collections.Generic;
using System.Text;
using System.Runtime.InteropServices;

namespace Components.Calendar.MonthCal.GUI
{
    /// <summary>
    /// EventArgs of a DayClicked
    /// </summary>
    public class DayClickedEventArgs : EventArgs
    {
        #region Variables
        /// <summary>
        /// DateToDisplay of the clicked day
        /// </summary>
        private DateTime vDateKey;
        #endregion

        #region Constructeur
        /// <summary>
        /// Constructor
        /// </summary>
        /// <param name="_DateKey">DateToDisplay of the clicked day</param>
        public DayClickedEventArgs(DateTime _DateKey) { vDateKey = _DateKey; }
        #endregion

        #region Accesseurs
        /// <summary>
        /// Gets the date of the clicked day
        /// </summary>
        public DateTime Date { get { return vDateKey; } }
        #endregion
    }
    /// <summary>
    /// Represents the method that will handle an DeyClicked event that has DayClickedEventArgs data
    /// </summary>
    /// <param name="sender">Event sender</param>
    /// <param name="args">Information about the clicked day</param>    
    [Serializable]
    [ComVisible(true)]
    public delegate void DayClickedEventHandler(object sender, DayClickedEventArgs args);
}
